function vexpower.panel_markers()		
	return {
		type = "group",
		order= 5,
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "activate",
						order=1, type = "toggle", width="double",
						set = function(info,val) vexpower.testmode=val vexpower_global_testmode(val) end,
						get = function() return vexpower.testmode end,
						},
					info = {name ="- ComboPoint gain and loss are simulated\n- Textfields get a colored background and are moveable\n- Powerbar gets movable\n'/vexp testmode' can be used to toggle the testmode", type = "description", order=2},
					},
				},
			spacetestmode = {name ="\n", type = "description", order=2},
			
			grpex = {
				name = "Examples",
				order=5, type = "group", dialogInline = true,
				args = {
					infopic={name = "", type="description", order=1, image="Interface\\AddOns\\vexpower\\images\\options_markers.tga",
						imageWidth=512, imageHeight=64},	
					info1={name = "Examples for markers are in the red circles\n", type="description", order=2,},	
					info2={name = "Markers are marks at specific places on your energybar. They can be placed at absolute positions and at relative positions.", type="description", order=3, fontSize="medium"},	
					info3={name = "'50' will be placed on the energybar that represents 50 of your mana/energy/etc", type="description", order=4, fontSize="medium"},	
					info4={name = "'50%' will be placed on the energybar that represents 50% of your mana/energy/etc", type="description", order=5, fontSize="medium"},	
					info5={name = "You can also create specific markers that shall only be shown with specific powertypes. That way druids can set markers for specific forms. By setting a marker for energy only the marker will only be shown when they are in their cat-form.", type="description", order=8, fontSize="medium"},
					space1={name= " ", type="description", order=1000},
					},
				},
			frame_space = {name =" ", type = "description", order=6},
			
			
			grpadd = {
				name = "Add/Overwrite marker",
				order=10, type ="group", dialogInline = true,
				args = {
					marker_new = {
						name = "Location",
						desc = "Enter a location where to put the new marker",
						order=1, type = "input", multiline = false,
						validate = function (info, val)
							if vexpower_panel_markercheck(val) then return true
							else print("ERROR - "..val.." is not a valid position") return false end
							end,
						set = function(info,val) vexpower_new_marker_location=val end,
						get = function() return vexpower_new_marker_location end,
						},
					marker_new_spec = {
						name = "Visible for",
						order=2, type = "select", style = "dropdown",
						values = {[""]="Both Specs", ["a"]="Primary Spec", ["b"]="Secondary Spec"},
						set = function(self,key) vexpower_new_marker_spec = key end,
						get = function() return vexpower_new_marker_spec end,
						},
					powertypes = {
						name = "Visible with the following powertypes",
						order=3, type ="group", dialogInline = true,
						args = {
							marker_new_powertype_rage = {
								name = "|CFF"..vexpower_PowerTypeColorHex("RAGE").."(R)age|r",
								order=1, type = "toggle", width="half",
								set = function(self,key) vexpower_new_marker_powertype["RAGE"] = key vexpower_initialize(true) end,
								get = function() return vexpower_new_marker_powertype["RAGE"] end,
								},
							marker_new_powertype_mana = {
								name = "|CFF"..vexpower_PowerTypeColorHex("MANA").."(M)ana|r",
								order=2, type = "toggle", width="half",
								set = function(self,key) vexpower_new_marker_powertype["MANA"] = key vexpower_initialize(true) end,
								get = function() return vexpower_new_marker_powertype["MANA"] end,
								},
							marker_new_powertype_focus = {
								name = "|CFF"..vexpower_PowerTypeColorHex("FOCUS").."(F)ocus|r",
								order=3, type = "toggle", width="half",
								set = function(self,key) vexpower_new_marker_powertype["FOCUS"] = key vexpower_initialize(true) end,
								get = function() return vexpower_new_marker_powertype["FOCUS"] end,
								},
							marker_new_powertype_energy = {
								name = "|CFF"..vexpower_PowerTypeColorHex("ENERGY").."(E)nergy|r",
								order=4, type = "toggle", width="half",
								set = function(self,key) vexpower_new_marker_powertype["ENERGY"] = key vexpower_initialize(true) end,
								get = function() return vexpower_new_marker_powertype["ENERGY"] end,
								},
							marker_new_powertype_rp = {
								name = "|CFF"..vexpower_PowerTypeColorHex("RUNIC_POWER").."(R)unic (P)ower|r",
								order=5, type = "toggle",
								set = function(self,key) vexpower_new_marker_powertype["RUNIC_POWER"] = key vexpower_initialize(true) end,
								get = function() return vexpower_new_marker_powertype["RUNIC_POWER"] end,
								},
							},
						},
					marker_new_add = {
						name = "add",
						order=4, type = "execute",
						func = function(info,val) vexpower_panel_addmarker() vexpower_initialize(true) end,
						},
					marker_new_info = {name = vexpower_marker_status_created, type = "description", order=20},
					},
				},
			grpadddelete_space = {name =" ", type = "description", order=11},
			
			grpdelete = {
				name = "Delete marker",
				order=20, type ="group", dialogInline = true,
				args = {
					marker_delete = {
						name = "Both specs",
						order=1, type = "select", style = "dropdown",
						desc = "Delete an existing marker",
						values = vexpower_panel_getMarker("both"),
						set = function(self,key) vexpower_panel_deletemarker(key, "") vexpower_initialize(true) end,
						get = function() return "" end,
						},
					marker_delete_a = {
						name = "Primary Spec",
						order=2, type = "select", style = "dropdown",
						desc = "Delete an existing marker",
						values = vexpower_panel_getMarker("spec a"),
						set = function(self,key) vexpower_panel_deletemarker(key, "a") vexpower_initialize(true) end,
						get = function() return "" end,
						},
					marker_delete_b = {
						name = "Secondary Spec",
						order=3, type = "select", style = "dropdown",
						desc = "Delete an existing marker",
						values = vexpower_panel_getMarker("spec b"),
						set = function(self,key) vexpower_panel_deletemarker(key, "b") vexpower_initialize(true) end,
						get = function() return "" end,
						},
					marker_deleted_info= {name = vexpower_marker_status_deleted, type = "description", order=4},
					},
				},
			frame_space1 = {name =" ", type = "description", order=21},
			
			grpapp = {
				name = "Appearance",
				order=100, type = "group", dialogInline = true,
				args = {
					width = {
						name = "Size",
						order=1, type = "range",
						desc = "Sets the width of the marker",
						step = 1, min = 1, max = 10,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["width"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["width"] end,
						},
					borderwidth = {
						name = "Border Size",
						order=2, type = "range",
						desc = "Sets the width of the border",
						step = 1, min = 1, max = 10,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"] end,
						},
					space1 = {name =" ", type = "description", order=3},
					
					bgcolor = {
						name = "Background Color",
						order=10, type = "color", hasAlpha=false,
						desc = "Set the marker's background color",
						disabled = vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"],
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"]=b
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"] end,
						},
					bgcolor_likebar = {
						name = "Use powerbar's color",
						order=11, type = "toggle",
						set = function(self,key) vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"] end,
						},
					bgopacity = {
						name = "Opacity %",
						order=12, type = "range",
						desc = "Sets the opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"]=val/100 vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"]*100 end
						},	
					space2 = {name =" ", type = "description", order=13},
					
					borderborder = {
						name = "Border Color",
						order=20, type = "color", hasAlpha=false,
						desc = "Set the marker's border color",
						disabled = vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"],
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"]=b
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"] end,
						},
					bordercolor_likebar = {
						name = "Use powerbar's color",
						order=21, type = "toggle",
						set = function(self,key) vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"] end,
						},
					borderopacity = {
						name = "Opacity %",
						order=22, type = "range",
						desc = "Sets the opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"]=val/100 vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"]*100 end
						},
					},
				},
			}
		}
end
