function vexpower.panel_text()
	if vexpower_panelText_textfield == "" then
		vexpower_panelText_textfield = vexpower_panelText_getFirstTextfield()
	end
	local tagvalues = {
		["PowerCurrent"] = "PowerCurrent",
		["PowerCurrentShort"] = "PowerCurrentShort",
		["PowerCurrentSmart"] = "PowerCurrentSmart",
		["PowerMax"] = "PowerMax",
		["PowerMaxShort"] = "PowerMaxShort",
		["PowerMaxSmart"] = "PowerMaxSmart",
		["PowerMissing"] = "PowerMissing",
		["PowerMissingShort"] = "PowerMissingShort",
		["PowerMissingSmart"] = "PowerMissingSmart",
		["PowerPerc"] = "PowerPerc",
		["PowerPercSmart"] = "PowerPercSmart",
		["BuffDurationTotal"] = "BuffDurationTotal",
		["BuffDurationLeft"] = "BuffDurationLeft",
		["BuffDurationLeftShort"] = "BuffDurationLeftShort",
		["CPsCurrent"] = "CPsCurrent",
		["CPsMax"] = "CPsMax",
		["CPsMissing"] = "CPsMissing",
		["PowerAltCurrent"] = "PowerAltCurrent",
		["PowerAltMax"] = "PowerAltMax",
		}

	return {
		type = "group",
		order= 3,
		args = {
			grptestmode = {
				name = "Testmode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "activate",
						order=1, type = "toggle", width="double",
						set = function(info,val) vexpower.testmode=val vexpower_global_testmode(val) end,
						get = function() return vexpower.testmode end,
						},
					info = {name ="- ComboPoint gain and loss are simulated\n- Textfields get a colored background and are moveable\n- Powerbar gets movable\n'/vexp testmode' can be used to toggle the testmode", type = "description", order=2},
					},
				},
			spacetestmode = {name ="\n", type = "description", order=2},
			
			edit = {
				name = "Textfield",
				order=5, type ="group", dialogInline = true,
				args = {
					profile = {
						name = "Textfield",
						order=1, type = "select", style = "dropdown",
						values = vexpower_panelText_getTextList(),
						set = function(self,val) vexpower_panelText_textfield = val vexpower_initialize(true) end,
						get = function() return vexpower_panelText_textfield end,
						},
					new = {
						name = "new",
						order=2, type = "execute", width="half",
						func = function(info,val) vexpower_panelText_New() vexpower_initialize(true) end,
						},
					clone = {
						name = "clone",
						order=3, type = "execute", width="half",
						func = function(info,val) vexpower_panelText_Clone() vexpower_initialize(true) end,
						},
					delete = {
						name = "delete",
						order=4, type = "execute", width="half",
						func = function(info,val) vexpower_panelText_Delete() vexpower_initialize(true) end,
						confirm = true,
						confirmText = "Are you sure you want to delete the textfield?"
						},
					status = {name = vexpower_panelText_status.."\n", type = "description", order=5},
					
					config = {
						name = "Setup",
						order=11, type ="group", dialogInline = true,
						args = {
							framelefttextcontent = {
								name = "Text",
								desc = "Text that is shown left", width="full",
								order=1, type = "input", multiline = false,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("text", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("text") end
								},
							frameleftinserttag = {
								name = "Insert Tag",
								order=2, type = "select", style = "dropdown",
								values = tagvalues,
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panel_TagInsert("left", val) vexpower_initialize(true) end,
								get = function() return "" end,
								},
							help = {
								name = "help",
								order=3, type = "execute", width="half",
								func = function(info,val) vexpower_toggleTagWindow() end,
								},
								
							helpspace = {name = " ", type = "description", order=4},
							powerBar = {
								name = "Bind to ComboPointBar instead of the PowerBar",
								order=5, type = "toggle", width="full",
								desc = "",
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("cptext", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("cptext") end,
								},
							info = {name ="When a Textfield is bond to a bar, the text is hidden when the bar is hidden. Thus textfields on ComboPoints should be bond to the ComboPointbar.\n", type = "description", order=6},

							font = {
								name = "Font",
								order=100, type = "select",
								dialogControl = "LSM30_Font",
								disabled = vexpower_panelText_getDisabled(),
								values = vexpower.LSM:HashTable("font"),
								set = function(self,val) vexpower_panelText_setDataDirect("font", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("font") end,
								},
							size = {
								name = "Size",
								order=101, type = "range",
								step = 1, min = 6, max = 20,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("size", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("size") end,
								},
							spacealign = {name = " ", type="description", order=102},
							align = {
								name = "Text align",
								order=103, type = "select", style = "dropdown",
								desc = "Sets the text align",
								disabled = vexpower_panelText_getDisabled(),
								values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
								set = function(self,val) vexpower_panelText_setDataDirect("align", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("align") end,
								},
							effect = {
								name = "effect",
								order=104, type = "select", style = "dropdown",
								values = {["MONOCHROME"]="Monochrome",
											["OUTLINE"]="Outline",
											[""]="None",
											["THICKOUTLINE"]="Thickoutline"},
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("effect", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("effect") end,
								},
							color = {
								name = "color",
								order=105, type = "color", hasAlpha=true,
								desc = "Sets the text color",
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,r,g,b,a)
									vexpower_panelText_setDataColor("r", r)
									vexpower_panelText_setDataColor("g", g)
									vexpower_panelText_setDataColor("b", b)
									vexpower_panelText_setDataColor("a", a)
									vexpower_initialize(true) end,
								get = function() return
									vexpower_panelText_getDataColor("r"),
									vexpower_panelText_getDataColor("g"),
									vexpower_panelText_getDataColor("b"),
									vexpower_panelText_getDataColor("a") end,
								},

							spacesize = {name = " ", type="description", order=199},
							width = {
								name = "Width",
								order=200, type = "range",
								step = 1, min = 1, max = 400,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("width", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("width") end
								},

							spaceposi = {name = " ", type="description", order=299},
							x = {
								name = "X Position",
								order=300, type = "range",
								step = 1, min = -300, max = 300,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("x", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("x") end
								},
							y = {
								name = "Y Position",
								order=301, type = "range",
								step = 1, min = -300, max = 300,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("y", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("y") end
								},
							spaceanchor = {name = " ", type="description", order=302},
							anchor = {
								name = "Anchor Textfield",
								order=303, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottomleft",
									["BOTTOMRIGHT"]="Bottomright",
									["TOPLEFT"]="Topleft",
									["TOPRIGHT"]="Topright"},
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("anchor", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("anchor") end,
								},
							anchor2 = {
								name = "Anchor Powerbar",
								order=304, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottomleft",
									["BOTTOMRIGHT"]="Bottomright",
									["TOPLEFT"]="Topleft",
									["TOPRIGHT"]="Topright"},
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("anchor2", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("anchor2") end,
								},
								
							spaceshadow = {name = " ", type="description", order=399},
							grpshadow = {
								name = "Shadow Effect",
								order=400, type ="group", dialogInline = true,
								args = {
									allow = {
										name = "Activate shadow effect",
										order=1, type = "toggle", width="full",
										desc = "",
										disabled = vexpower_panelText_getDisabled(),
										set = function(self,val) vexpower_panelText_setDataShadow(false, "allow", val) vexpower_initialize(true) end,
										get = function() return vexpower_panelText_getDataShadow(false, "allow") end,
										},
									color = {
										name = "color",
										disabled = vexpower_panelText_getDisabled(),
										order=2, type = "color", hasAlpha=true, width="double",
										hidden = not(vexpower_panelText_getDataShadow(false, "allow")),
										set = function(info,r,g,b,a)
											vexpower_panelText_setDataShadow("color", "r", r)
											vexpower_panelText_setDataShadow("color", "g", g)
											vexpower_panelText_setDataShadow("color", "b", b)
											vexpower_panelText_setDataShadow("color", "a", a)
											vexpower_initialize(true) end,
										get = function() return
											vexpower_panelText_getDataShadow("color", "r"),
											vexpower_panelText_getDataShadow("color", "g"),
											vexpower_panelText_getDataShadow("color", "b"),
											vexpower_panelText_getDataShadow("color", "a") end,
										},
									opacity = {
										name = "Opacity %",
										order=3, type = "range",
										step = 5, min = 0, max = 100,
										hidden = not(vexpower_panelText_getDataShadow(false, "allow")),
										disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
										set = function(info,val) vexpower_panelText_setDataShadow("color", "a", val/100) vexpower_initialize(true) end,
										get = function() return vexpower_panelText_getDataShadow("color", "a") end
										},
									x = {
										name = "X Position",
										order=4, type = "range",
										step = 1, min = -50, max = 50,
										hidden = not(vexpower_panelText_getDataShadow(false, "allow")),
										disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
										set = function(info,val) vexpower_panelText_setDataShadow("offset", "x", val) vexpower_initialize(true) end,
										get = function() return vexpower_panelText_getDataShadow("offset", "x") end
										},
									y = {
										name = "Y Position",
										order=5, type = "range",
										step = 1, min = -50, max = 50,
										hidden = not(vexpower_panelText_getDataShadow(false, "allow")),
										disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
										set = function(info,val) vexpower_panelText_setDataShadow("offset", "y", val) vexpower_initialize(true) end,
										get = function() return vexpower_panelText_getDataShadow("offset", "y") end
										},
									},
								},
							},
						},
					}
				}
			}
		}
end